--Script para animacoes manuais
--
--Autor original: ?
--Edicao: Vinicius LS
--

ManualAnimations = {}

function ManualAnimations.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Sprayer, specializations);
end;

function ManualAnimations:load(xmlFile) 
-- Animacao 1  
   local rotationPartNodeAnimation1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Animation1#index"));
	if rotationPartNodeAnimation1 ~= nil then
        self.Animation1 = {};
        self.Animation1.node = rotationPartNodeAnimation1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation1#minRot"));
        self.Animation1.minRot = {};
        self.Animation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation1#maxRot"));
        self.Animation1.maxRot = {};
        self.Animation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Animation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation1#rotTime"), 2)*1000;
        self.Animation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation1#touchRotLimit"), 10))
    end;
--Animacao 2
	local rotationPartNodeAnimation2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Animation2#index"));
	if rotationPartNodeAnimation2 ~= nil then
        self.Animation2 = {};
        self.Animation2.node = rotationPartNodeAnimation2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation2#minRot"));
        self.Animation2.minRot = {};
        self.Animation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation2#maxRot"));
        self.Animation2.maxRot = {};
        self.Animation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Animation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation2#rotTime"), 2)*1000;
        self.Animation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation2#touchRotLimit"), 10))
    end;
--Animacao 3
	local rotationPartNodeAnimation3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Animation3#index"));
	if rotationPartNodeAnimation3 ~= nil then
        self.Animation3 = {};
        self.Animation3.node = rotationPartNodeAnimation3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation3#minRot"));
        self.Animation3.minRot = {};
        self.Animation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation3#maxRot"));
        self.Animation3.maxRot = {};
        self.Animation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Animation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation3#rotTime"), 2)*1000;
        self.Animation3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation3#touchRotLimit"), 10))
    end;
--Animacao 4
	local rotationPartNodeAnimation4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Animation4#index"));
	if rotationPartNodeAnimation4 ~= nil then
        self.Animation4 = {};
        self.Animation4.node = rotationPartNodeAnimation4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation4#minRot"));
        self.Animation4.minRot = {};
        self.Animation4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Animation4#maxRot"));
        self.Animation4.maxRot = {};
        self.Animation4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Animation4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Animation4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Animation4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation4#rotTime"), 2)*1000;
        self.Animation4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Animation4#touchRotLimit"), 10))
    end;
--Animacao 5
	local translationPartNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart4#index"));
    if translationPartNode4 ~= nil then
        self.translationPart4 = {};
        self.translationPart4.node = translationPartNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#minTrans"));
        self.translationPart4.minTrans = {};
        self.translationPart4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#maxTrans"));
        self.translationPart4.maxTrans = {};
        self.translationPart4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#transTime"), 2)*1000;
        self.translationPart4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#touchTransLimit"), 10);
    end;
end;

function ManualAnimations:delete()
end;

function ManualAnimations:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ManualAnimations:keyEvent(unicode, sym, modifier, isDown)
--Animacao 1    
	if sym == Input.KEY_KP_7 then
		self.rotationMinAnimation1 = isDown;
	end;
	
	if sym == Input.KEY_KP_4 then
		self.rotationMaxAnimation1 = isDown;
	end;
--Animacao 2
	if sym == Input.KEY_KP_8 then
		self.rotationMinAnimation2 = isDown;
	end;
	
	if sym == Input.KEY_KP_5 then
		self.rotationMaxAnimation2 = isDown;
	end;
--Animacao 3
	if sym == Input.KEY_KP_9 then
		self.rotationMinAnimation3 = isDown;
	end;
	
	if sym == Input.KEY_KP_6 then
		self.rotationMaxAnimation3 = isDown;
	end;
--Animacao 4
	if sym == Input.KEY_KP_1 then
		self.rotationMinAnimation4 = isDown;
	end;
	
	if sym == Input.KEY_KP_0 then
		self.rotationMaxAnimation4 = isDown;
	end;
--Animacao 5
	if sym == Input.KEY_k then
		self.translationMin4 = isDown;
    end;
	if sym == Input.KEY_m then
	    self.translationMax4 = isDown;
	end;
end;

function ManualAnimations:update(dt)
-- Animacao 1
local doRotate = self.rotationMaxAnimation1 or self.rotationMinAnimation1
    if self.Animation1 ~= nil and doRotate then
		local x, y, z = getRotation(self.Animation1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Animation1.maxRot, self.Animation1.minRot, 3, self.Animation1.rotTime, dt, not self.rotationMaxAnimation1);
		setRotation(self.Animation1.node, unpack(newRot));		
	end;
--Animacao 2
local doRotate = self.rotationMaxAnimation2 or self.rotationMinAnimation2
    if self.Animation2 ~= nil and doRotate then
		local x, y, z = getRotation(self.Animation2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Animation2.maxRot, self.Animation2.minRot, 3, self.Animation2.rotTime, dt, not self.rotationMaxAnimation2);
		setRotation(self.Animation2.node, unpack(newRot));		
	end;
--Animacao 3
local doRotate = self.rotationMaxAnimation3 or self.rotationMinAnimation3
    if self.Animation3 ~= nil and doRotate then
		local x, y, z = getRotation(self.Animation3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Animation3.maxRot, self.Animation3.minRot, 3, self.Animation3.rotTime, dt, not self.rotationMaxAnimation3);
		setRotation(self.Animation3.node, unpack(newRot));		
	end;
--Animacao 4
local doRotate = self.rotationMaxAnimation4 or self.rotationMinAnimation4
    if self.Animation4 ~= nil and doRotate then
		local x, y, z = getRotation(self.Animation4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Animation4.maxRot, self.Animation4.minRot, 3, self.Animation4.rotTime, dt, not self.rotationMaxAnimation4);
		setRotation(self.Animation4.node, unpack(newRot));		
	end;
--Animacao 5
local doTranslation = self.translationMax4 or self.translationMin4
	if self.translationMax4 ~= nil and doTranslation then
		local x, y, z = getTranslation(self.translationPart4.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart4.maxTrans, self.translationPart4.minTrans, 3, self.translationPart4.transTime, dt, not self.translationMax4);
        setTranslation(self.translationPart4.node, unpack(newTrans));
	end;
end;

function ManualAnimations:draw()
end;